diff -crN nakedmudv1.5/src/bitvector.c nakedmudv2.0/src/bitvector.c
*** nakedmudv1.5/src/bitvector.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/bitvector.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,250 ----
+ //*****************************************************************************
+ //
+ // bitvector.c
+ //
+ // One of the questions that came up when designing NakedMud is, how do we
+ // efficiently implement bitvectors while maintaining the modularity of the mud?
+ // For those unfamiliar with the purposes of a bitvector, let me elaborate:
+ // there are many instances in which we may want to know about the presence or
+ // absence of a property (e.g. is the room dark? is the character blind?). We
+ // could easily have a variable for each of these properties in the relevant
+ // datastructures, but this is often quite wasteful on memory. What would be
+ // really nice is if we could compress the space that it took to store one
+ // bit of information (in C, the smallest basic datatype is 8 bits ... i.e. we
+ // are wasting 7 bits to store a piece of information that be represented as
+ // on/off). In a nutshell, this is the purpose of a bitvector (there are more
+ // reasons why bitvectors are attractive, but this is perhaps the most important
+ // one in the context of muds).
+ //
+ // For anyone who has ever worked on a DIKU-derivative, they know that
+ // bits in a bitvector are typically declared on after another like this:
+ //    #define BIT_ONE    (1 << 0)
+ //    #define BIT_TWO    (1 << 1)
+ //    #define BIT_THREE  (1 << 2)
+ //    ...
+ //
+ // Of course, this is hugely unattractive for us: If we had a module that wanted
+ // to add a new bit, we surely would not want to add it to some global header
+ // file; we would want to keep the definition within the module headers. And,
+ // most certainly we cannot do this because we have to assocciate a position
+ // with each bit name, and every other module has to know that position so that
+ // noone else adds a new bit with the same position. This module is an attempt
+ // to address this problem, allowing modules to use bits, keep their 
+ // declarations in some place local to the module, and make sure there are no
+ // conflicting definitions. This also ensures that bits are persistent for all
+ // rooms, objects, and characters (ie. they save if we crash, or the player
+ // logs off, or whatnot).
+ //
+ //*****************************************************************************
+ 
+ #include "mud.h"
+ #include "utils.h"
+ 
+ #include "bitvector.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // local functions, datastructures, and defines
+ //*****************************************************************************
+ 
+ // optimally, this should be about 120% bigger than the number
+ // of distinct types of bitvectors we'd expect to have in the game
+ #define BITVECTOR_TABLE_SIZE      50
+ 
+ // a table of mappings between bitvector names, and the 
+ // data assocciated with them (i.e. bit:value mappings)
+ HASHTABLE *bitvector_table = NULL;
+ 
+ typedef struct bitvector_data {
+   HASHTABLE *bitmap; // a mapping from bit name to bit number
+   char        *name; // which bitvector is this?
+ } BITVECTOR_DATA;
+ 
+ struct bitvector {
+   BITVECTOR_DATA *data; // the data corresponding to this bitvector
+   char           *bits; // the bits we have set/unset
+ };
+ 
+ BITVECTOR_DATA *newBitvectorData(const char *name) {
+   BITVECTOR_DATA *data = malloc(sizeof(BITVECTOR_DATA));
+   data->bitmap = newHashtable(32);
+   data->name   = strdup(name);
+   return data;
+ }
+ 
+ 
+ 
+ 
+ //*****************************************************************************
+ // implementation of bitvector.h
+ //*****************************************************************************
+ void init_bitvectors() {
+   // create the bitvector table
+   bitvector_table = newHashtable(BITVECTOR_TABLE_SIZE);
+ 
+   // and also create some of the basic bitvectors and 
+   // bits that come stock and are required for the core release
+   bitvectorCreate("char_prfs");
+   bitvectorAddBit("char_prfs", "buildwalk");
+ 
+   bitvectorCreate("obj_bits");
+   bitvectorAddBit("obj_bits", "notake");
+ }
+ 
+ void bitvectorAddBit(const char *name, const char *bit) {
+   BITVECTOR_DATA *data = hashGet(bitvector_table, name);
+   if(data != NULL)
+     hashPut(data->bitmap, bit, (void *)(hashSize(data->bitmap) + 1));
+ }
+ 
+ void bitvectorCreate(const char *name) {
+   if(!hashGet(bitvector_table, name))
+     hashPut(bitvector_table, name, newBitvectorData(name));
+ }
+ 
+ BITVECTOR *newBitvector() {
+   BITVECTOR *v = malloc(sizeof(BITVECTOR));
+   bzero(v, sizeof(BITVECTOR));
+   return v;
+ }
+ 
+ BITVECTOR   *bitvectorInstanceOf(const char *name) {
+   BITVECTOR_DATA *data = hashGet(bitvector_table, name);
+   BITVECTOR    *vector = NULL;
+   if(data != NULL) {
+     int vector_len = hashSize(data->bitmap)/8 + 1;
+     vector = newBitvector();
+     vector->data = data;
+     vector->bits = malloc(sizeof(char) * vector_len);
+     bzero(vector->bits, vector_len);
+   }
+   return vector;
+ }
+ 
+ void         deleteBitvector(BITVECTOR *v) {
+   if(v->bits) free(v->bits);
+   free(v);
+ }
+ 
+ void         bitvectorCopyTo(BITVECTOR *from, BITVECTOR *to) {
+   int bit_len = 1 + hashSize(from->data->bitmap)/8;
+   to->data = from->data;
+   if(to->bits) free(to->bits);
+   to->bits = malloc(sizeof(char) * bit_len);
+   to->bits = memcpy(to->bits, from->bits, bit_len);
+ }
+ 
+ BITVECTOR   *bitvectorCopy(BITVECTOR *v) {
+   BITVECTOR *newvector = bitvectorInstanceOf(v->data->name);
+   bitvectorCopyTo(v, newvector);
+   return newvector;
+ }
+ 
+ bool bitIsSet(BITVECTOR *v, const char *bit) {
+   // first, parse all of the names
+   bool found = FALSE;
+   int i, num_names = 0;
+   char **bits = parse_keywords(bit, &num_names);
+ 
+   // check for one
+   for(i = 0; i < num_names && !found; i++) {
+     found = bitIsOneSet(v, bits[i]);
+     free(bits[i]);
+   }
+ 
+   // continue our clean up
+   for(; i < num_names; i++)
+     free(bits[i]);
+   free(bits);
+   return found;
+ }
+ 
+ bool bitIsAllSet(BITVECTOR *v, const char *bit) {
+   // first, parse all of the names
+   bool found = TRUE;
+   int i, num_names = 0;
+   char **bits = parse_keywords(bit, &num_names);
+ 
+   // check for each one
+   for(i = 0; i < num_names && found; i++) {
+     found = bitIsOneSet(v, bits[i]);
+     free(bits[i]);
+   }
+ 
+   // continue our clean up
+   for(; i < num_names; i++)
+     free(bits[i]);
+   free(bits);
+   return found;
+ }
+ 
+ bool bitIsOneSet(BITVECTOR *v, const char *bit) {
+   int val = (int)hashGet(v->data->bitmap, bit);
+   return IS_SET(v->bits[val/8], (1 << (val % 8)));
+ }
+ 
+ void bitSet(BITVECTOR *v, const char *name) {
+   // first, parse all of the names
+   int i, num_names = 0;
+   char **bits = parse_keywords(name, &num_names);
+ 
+   // set each one
+   for(i = 0; i < num_names; i++) {
+     int val = (int)hashGet(v->data->bitmap, bits[i]);
+     free(bits[i]);
+     // 0 is a filler meaning 'this is not an actual name for a bit'
+     if(val == 0) continue;
+     SET_BIT(v->bits[val/8], (1 << (val % 8)));
+   }
+   free(bits);
+ }
+ 
+ void bitRemove(BITVECTOR *v, const char *name) {
+   // first, parse all of the names
+   int i, num_names = 0;
+   char **bits = parse_keywords(name, &num_names);
+ 
+   // set each one
+   for(i = 0; i < num_names; i++) {
+     int val = (int)hashGet(v->data->bitmap, bits[i]);
+     REMOVE_BIT(v->bits[val/8], (1 << (val % 8)));
+     free(bits[i]);
+   }
+   free(bits);
+ }
+ 
+ void bitToggle(BITVECTOR *v, const char *name) {
+   // first, parse all of the names
+   int i, num_names = 0;
+   char **bits = parse_keywords(name, &num_names);
+ 
+   // set each one
+   for(i = 0; i < num_names; i++) {
+     int val = (int)hashGet(v->data->bitmap, bits[i]);
+     free(bits[i]);
+     // 0 is a filler meaning 'this is not an actual name for a bit'
+     if(val == 0) continue;
+     TOGGLE_BIT(v->bits[val/8], (1 << (val % 8)));
+   }
+   free(bits);
+ }
+ 
+ const char *bitvectorGetBits(BITVECTOR *v) {
+   static char bits[MAX_BUFFER];
+   HASH_ITERATOR *hash_i = newHashIterator(v->data->bitmap);
+   const char *key = NULL;
+   void *val       = NULL;
+   int bit_i       = 0;
+   *bits = '\0';
+ 
+   // add each set bit to our list to store
+   ITERATE_HASH(key, val, hash_i) {
+     if(bitIsOneSet(v, key)) {
+       bit_i += snprintf(bits+bit_i, MAX_BUFFER-bit_i, "%s%s", 
+ 			(bit_i == 0 ? "" : ", "), key);
+     }
+   }
+   deleteHashIterator(hash_i);
+   return bits;
+ }
diff -crN nakedmudv1.5/src/bitvector.d nakedmudv2.0/src/bitvector.d
*** nakedmudv1.5/src/bitvector.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/bitvector.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ bitvector.d bitvector.o: bitvector.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h
diff -crN nakedmudv1.5/src/bitvector.h nakedmudv2.0/src/bitvector.h
*** nakedmudv1.5/src/bitvector.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/bitvector.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,100 ----
+ #ifndef BITVECTOR_H
+ #define BITVECTOR_H
+ //*****************************************************************************
+ //
+ // bitvector.h
+ //
+ // One of the questions that came up when designing NakedMud is, how do we
+ // efficiently implement bitvectors while maintaining the modularity of the mud?
+ // For those unfamiliar with the purposes of a bitvector, let me elaborate:
+ // there are many instances in which we may want to know about the presence or
+ // absence of a property (e.g. is the room dark? is the character blind?). We
+ // could easily have a variable for each of these properties in the relevant
+ // datastructures, but this is often quite wasteful on memory. What would be
+ // really nice is if we could compress the space that it took to store one
+ // bit of information (in C, the smallest basic datatype is 8 bits ... i.e. we
+ // are wasting 7 bits to store a piece of information that be represented as
+ // on/off). In a nutshell, this is the purpose of a bitvector (there are more
+ // reasons why bitvectors are attractive, but this is perhaps the most important
+ // one in the context of muds).
+ //
+ // For anyone who has ever worked on a DIKU-derivative, they know that
+ // bits in a bitvector are typically declared on after another like this:
+ //    #define BIT_ONE    (1 << 0)
+ //    #define BIT_TWO    (1 << 1)
+ //    #define BIT_THREE  (1 << 2)
+ //    ...
+ //
+ // Of course, this is hugely unattractive for us: If we had a module that wanted
+ // to add a new bit, we surely would not want to add it to some global header
+ // file; we would want to keep the definition within the module headers. And,
+ // most certainly we cannot do this because we have to assocciate a position
+ // with each bit name, and every other module has to know that position so that
+ // noone else adds a new bit with the same position. This module is an attempt
+ // to address this problem, allowing modules to use bits, keep their 
+ // declarations in some place local to the module, and make sure there are no
+ // conflicting definitions. This also ensures that bits are persistent for all
+ // rooms, objects, and characters (ie. they save if we crash, or the player
+ // logs off, or whatnot).
+ //
+ //*****************************************************************************
+ 
+ typedef struct bitvector BITVECTOR;
+ 
+ //
+ // prepare bitvector systems for use
+ void init_bitvectors();
+ 
+ //
+ // Create a new type of bitvector. This must be called before any bit types 
+ // can be added, or before a bitvector of the given name can be created
+ void bitvectorCreate(const char *name);
+ 
+ //
+ // Add a new bit to an existing bitvector. The bitvector must have already
+ // been created. Multiple bits can be added if their names are comma-separated.
+ // This should only be called after init_bitvectors() is run, and it should 
+ // never be called when the game is actually running (i.e. the world has loaded,
+ // mobs have spawned, etc...). Ideally, bitvectorAddBit should only ever be 
+ // called in a module's initialization function.
+ void bitvectorAddBit(const char *name, const char *bit);
+ 
+ //
+ // create a new instance of the bitvector with the given name. 
+ // Return NULL if a bitvector with the given name does not exist
+ BITVECTOR   *bitvectorInstanceOf(const char *name);
+ void         deleteBitvector(BITVECTOR *v);
+ void         bitvectorCopyTo(BITVECTOR *from, BITVECTOR *to);
+ BITVECTOR   *bitvectorCopy(BITVECTOR *v);
+ 
+ //
+ // checks to see if ANY of the bits in the name list are set. Name can be 
+ // a single bit, or a comma-separated list of bits
+ bool bitIsSet(BITVECTOR *v, const char *bit);
+ 
+ //
+ // checks to see if ALL of the bits in the name list are set
+ bool bitIsAllSet(BITVECTOR *v, const char *bit);
+ 
+ //
+ // Check to see if only one bit is set, unlike bit_is_set and
+ // bit_is_all_set, which check for potentially multiple functions
+ bool bitIsOneSet(BITVECTOR *v, const char *bit);
+ 
+ //
+ // set the bits in the name list onto the bitvector
+ void bitSet(BITVECTOR *v, const char *name);
+ 
+ //
+ // remove the bits in the name list from the bitvector
+ void bitRemove(BITVECTOR *v, const char *name);
+ 
+ //
+ // toggle the specified bits on or off... whichever one they are not, currently
+ void bitToggle(BITVECTOR *v, const char *name);
+ 
+ //
+ // return a comma-separated list of the bits the vector has set
+ const char *bitvectorGetBits(BITVECTOR *v);
+ 
+ #endif // BITVECTOR_H
diff -crN nakedmudv1.5/src/body.d nakedmudv2.0/src/body.d
*** nakedmudv1.5/src/body.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/body.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ body.d body.o: body.c mud.h wrapsock.h property_table.h list.h map.h hashtable.h \
+   set.h buffer.h bitvector.h body.h utils.h
diff -crN nakedmudv1.5/src/buffer.c nakedmudv2.0/src/buffer.c
*** nakedmudv1.5/src/buffer.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/buffer.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,311 ----
+ //*****************************************************************************
+ //
+ // buffer.c
+ //
+ // The buffer datastructure is a string-like thing of infinite length. Contains
+ // some basic utilities for interacting with it.
+ //
+ //*****************************************************************************
+ 
+ #include <stdarg.h>
+ #include <stdio.h>
+ #include <stdlib.h>
+ #include <string.h>
+ 
+ #include "mud.h"
+ #include "utils.h"
+ #include "buffer.h"
+ 
+ 
+ struct buffer_data {
+   char *data;   // what we're holding
+   int  maxlen;  // what's the maximum storage capacity of data
+   int  len;     // what's the current content length of data
+ };
+ 
+ BUFFER    *newBuffer   (int start_capacity) {
+   BUFFER *buf = malloc(sizeof(BUFFER));
+   buf->data   = malloc(sizeof(char) * start_capacity);
+   *buf->data  = '\0';
+   buf->maxlen = start_capacity;
+   buf->len    = 0;
+   return buf;
+ }
+ 
+ void        deleteBuffer(BUFFER *buf) {
+   free(buf->data);
+   free(buf);
+ }
+ 
+ void        bufferExpand(BUFFER *buf, int newsize) {
+   char *newdata = malloc(sizeof(char) * newsize);
+   strcpy(newdata, buf->data);
+   free(buf->data);
+   buf->maxlen = newsize;
+   buf->data = newdata;
+ }
+ 
+ void        bufferCat   (BUFFER *buf, const char *txt) {
+   int txtlen = strlen(txt);
+   // see if we need to expand the size of the buffer
+   if(txtlen + buf->len >= buf->maxlen)
+     bufferExpand(buf, ((txtlen + buf->len) * 5) / 4 + 20); 
+   // copy the new text over
+   strcat(buf->data+buf->len, txt);
+   buf->len += txtlen;
+ }
+ 
+ void        bufferClear (BUFFER *buf) {
+   *buf->data = '\0';
+   buf->len = 0;
+ }
+ 
+ BUFFER    *bufferCopy  (BUFFER *buf) {
+   BUFFER *newbuf = newBuffer(buf->maxlen);
+   memcpy(newbuf->data, buf->data, buf->maxlen);
+   newbuf->len = buf->len;
+   return newbuf;
+ }
+ 
+ void        bufferCopyTo(BUFFER *from, BUFFER *to) {
+   free(to->data);
+   to->data   = strdup(from->data);
+   to->len    = from->len;
+   to->maxlen = from->maxlen;
+ }
+ 
+ const char *bufferString(BUFFER *buf) {
+   return buf->data;
+ }
+ 
+ int         bufferLength(BUFFER *buf) {
+   return buf->len;
+ }
+ 
+ int bprintf(BUFFER *buf, char *fmt, ...) {  
+   static int printsize = 8192;
+   char buftmp[printsize];
+   va_list va;
+   int res;
+ 
+   va_start(va, fmt);
+   res = vsnprintf(buftmp, printsize, fmt, va);
+   va_end(va);
+     
+   if (res >= printsize - 1)
+     *buftmp = '\0';
+   else
+     bufferCat(buf, buftmp);
+    
+   return res;
+ }
+ 
+ int bufferReplace(BUFFER *buf, const char *a, const char *b, int all) {
+   // first, check if we'll need to expand the size of the buffer
+   int a_len = strlen(a), b_len = strlen(b);
+   int len_needed = buf->maxlen;
+   int replaced = 0;
+ 
+   if(b_len - a_len > 0) {
+     int to_replace = (all ? 
+ 		      count_occurences(buf->data, a) : 
+ 		      strstr(buf->data, a) != NULL);
+     // if we don't have any to replace, do nothing
+     if(to_replace == 0) return 0;
+ 
+     // if we won't have enough room, do the expansion
+     if(to_replace * (b_len - a_len) + buf->len > buf->maxlen)
+       len_needed = ((buf->maxlen + to_replace*(b_len-a_len))*5)/4 + 20;
+   }
+ 
+   int buf_i, tmp_i;
+   char buftmp[len_needed];
+ 
+   // go through and replace all the occurences we need to
+   for(buf_i = tmp_i = 0; buf->data[buf_i] != '\0';) {
+     // we found a match
+     if(!strncmp(buf->data+buf_i, a, a_len)) {
+       replaced++;
+       strcpy(buftmp+tmp_i, b);
+       buf_i += a_len;
+       tmp_i += b_len;
+       // exit if we only need to replace the first occurence
+       if(all == 0) break;
+     }
+     else {
+       buftmp[tmp_i] = buf->data[buf_i];
+       tmp_i++; buf_i++;
+     }
+   }
+ 
+   // continue filling up the tmpbuf (if we only replaced 1, and not all)
+   for(; buf->data[buf_i] != '\0'; buf_i++, tmp_i++)
+     buftmp[tmp_i] = buf->data[buf_i];
+ 
+   // make sure the end of string marker is in place
+   buftmp[tmp_i] = '\0';
+ 
+   // copy over all the changes
+   if(buf->maxlen >= len_needed) {
+     strcpy(buf->data, buftmp);
+     buf->len = tmp_i;
+   }
+   else {
+     free(buf->data);
+     buf->data = malloc(len_needed);
+     strcpy(buf->data, buftmp);
+     buf->maxlen = len_needed;
+     buf->len    = tmp_i;
+   }
+ 
+   return replaced;
+ }
+ 
+ 
+ int bufferInsert(BUFFER *buf, const char *newline, int line) {
+   // first, check if we'll need to expand the size of the buffer
+   int line_len = strlen(newline);
+   if(line_len + buf->len + 2 >= buf->maxlen) // +2 for \r\n
+     bufferExpand(buf, ((line_len + buf->len + 2) * 5)/4 + 20);
+ 
+   // insert it in
+   char *start = line_start(buf->data, line);
+   if(start != NULL) {
+     char tmpbuf[buf->maxlen];
+     sprintf(tmpbuf, "%s", start);
+     sprintf(start, "%s\r\n", newline);
+     strcpy(start+line_len+2, tmpbuf);
+     buf->len = buf->len + line_len + 2;
+     return TRUE;
+   }
+ 
+   return FALSE;
+ }
+ 
+ int bufferRemove(BUFFER *buf, int line) {
+   char *start = line_start(buf->data, line);
+   if(start == NULL) 
+     return FALSE;
+ 
+   int i;
+   // copy over the line with everything from the end of the line onwards
+   for(i = 0; start[i] != '\0'; i++) {
+     if(start[i] == '\n') {
+       i++;
+       break;
+     }
+   }
+   strcpy(start, start+i);
+   buf->len = strlen(buf->data);
+   return TRUE;
+ }
+ 
+ int bufferReplaceLine(BUFFER *buf, const char *newline, int line) {
+   if(bufferRemove(buf, line))
+     return bufferInsert(buf, newline, line);
+   else
+     return 0;
+ }
+ 
+ 
+ void bufferFormat(BUFFER *buf, int max_width, int indent) {
+   char formatted[(buf->len * 3)/2];
+   bool needs_capital = TRUE, needs_indent = FALSE;
+   int fmt_i = 0, buf_i = 0, col = 0;
+ 
+   // put in our indent
+   if(indent > 0) {
+     char fmt[20];
+     sprintf(fmt, "%%%ds", indent);
+     sprintf(formatted, fmt, " ");
+     fmt_i += indent;
+     col   += indent;
+ 
+     // skip the leading spaces
+     while(isspace(buf->data[buf_i]) && buf->data[buf_i] != '\0')
+       buf_i++;
+   }
+ 
+ 
+   for(; buf->data[buf_i] != '\0'; buf_i++) {
+     // we have to put a newline in because the word won't fit on the line
+     if(col + next_space_in(buf->data+buf_i) > max_width-2) {
+       formatted[fmt_i] = '\r'; fmt_i++;
+       formatted[fmt_i] = '\n'; fmt_i++;
+       col = 0;
+     }
+ 
+     char ch = buf->data[buf_i];
+ 
+     // no spaces on newlines
+     if(isspace(ch) && col == 0)
+       continue;
+     // we will do our own sentance formatting
+     else if(needs_capital && isspace(ch))
+       continue;
+     // delete multiple spaces
+     else if(isspace(ch) && fmt_i > 0 && isspace(formatted[fmt_i-1]))
+       continue;
+     // treat newlines as spaces (to separate words on different lines), 
+     // since we are creating our own newlines
+     else if(ch == '\r' || ch == '\n') {
+       // we've already spaced
+       if(col == 0)
+ 	continue;
+       formatted[fmt_i] = ' ';
+       col++;
+     }
+     // if someone is putting more than 1 sentence delimiter, we
+     // need to catch it so we will still capitalize the next word
+     else if(strchr("?!.", ch)) {
+       needs_capital = TRUE;
+       needs_indent  = TRUE;
+       formatted[fmt_i] = ch;
+       col++;
+     }
+     // see if we are the first letter after the end of a sentence
+     else if(needs_capital) {
+       // check if indenting will make it so we don't
+       // have enough room to print the word. If that's the
+       // case, then skip down to a new line instead
+       if(col + 2 + next_space_in(buf->data+buf_i) > max_width-2) {
+ 	formatted[fmt_i] = '\r'; fmt_i++;
+ 	formatted[fmt_i] = '\n'; fmt_i++;
+ 	col = 0;
+       }
+       // indent two spaces if we're not at the start of a line 
+       else if(needs_indent && buf_i-1 >= 0 && buf->data[buf_i-1] != '\n') {
+ 	formatted[fmt_i] = ' '; fmt_i++;
+ 	formatted[fmt_i] = ' '; fmt_i++;
+ 	col += 2;
+       }
+       // capitalize the first letter on the new word
+       formatted[fmt_i] = toupper(ch);
+       needs_capital = FALSE;
+       needs_indent  = FALSE;
+       col++;
+     }
+     else {
+       formatted[fmt_i] = ch;
+       col++;
+     }
+ 
+     fmt_i++;
+   }
+ 
+   // tag a newline onto the end of the string if there isn't one already
+   if(fmt_i > 0 && formatted[fmt_i-1] != '\n') {
+     formatted[fmt_i++] = '\r';
+     formatted[fmt_i++] = '\n';
+   }
+ 
+   formatted[fmt_i] = '\0';
+ 
+   // make sure we have enough room to copy everything over
+   if(fmt_i >= buf->maxlen)
+     bufferExpand(buf, (fmt_i * 5)/4 + 20);
+   
+   // copy over our changes
+   strcpy(buf->data, formatted);
+   buf->len = fmt_i;
+ }
diff -crN nakedmudv1.5/src/buffer.d nakedmudv2.0/src/buffer.d
*** nakedmudv1.5/src/buffer.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/buffer.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ buffer.d buffer.o: buffer.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h
diff -crN nakedmudv1.5/src/buffer.h nakedmudv2.0/src/buffer.h
*** nakedmudv1.5/src/buffer.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/buffer.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,58 ----
+ #ifndef BUFFER_H
+ #define BUFFER_H
+ //*****************************************************************************
+ //
+ // buffer.h
+ //
+ // The buffer datastructure is a string-like thing of infinite length. Contains
+ // some basic utilities for interacting with it.
+ //
+ //*****************************************************************************
+ 
+ typedef struct buffer_data BUFFER;
+ 
+ // allocate/deallocate a buffer. start capacity must be supplied, but the
+ // buffer can grow indefinitely.
+ BUFFER *newBuffer(int start_capacity);
+ void deleteBuffer(BUFFER *buf);
+ 
+ // concatinate the text to the end of the buffer
+ void        bufferCat   (BUFFER *buf, const char *txt);
+ 
+ // clear the buffer's contents
+ void bufferClear(BUFFER *buf);
+ 
+ // copy the contents of one buffer to another
+ void bufferCopyTo(BUFFER *from, BUFFER *to);
+ 
+ // return a copy of the buffer
+ BUFFER *bufferCopy(BUFFER *buf);
+ 
+ // return the string contents of the buffer
+ const char *bufferString(BUFFER *buf);
+ 
+ // return the length of the buffer's contents
+ int bufferLength(BUFFER *buf);
+ 
+ // do a formatted print onto the buffer (concats it)
+ int bprintf(BUFFER *buf, char *fmt, ...) __attribute__ ((format (printf, 2, 3)));
+ 
+ // replace 'a' with 'b'. Return back how many occurences were replaced. If
+ // all is FALSE, then only the first occurence is replaced.
+ int bufferReplace(BUFFER *buf, const char *a, const char *b, int all);
+ 
+ // insert the line into the string at the specified place. If the line was
+ // inserted, return TRUE. Otherwise, return FALSE.
+ int bufferInsert(BUFFER *buf, const char *newline, int line);
+ 
+ // delete the specified line. Return TRUE if successful and FALSE otherwise
+ int bufferRemove(BUFFER *buf, int line);
+ 
+ // replace the given line number with the new information. Return TRUE if
+ // successful and FALSE otherwise.
+ int bufferReplaceLine(BUFFER *buf, const char *newline, int line);
+ 
+ // format a string with the given arguments
+ void bufferFormat(BUFFER *buf, int max_width, int indent);
+ 
+ #endif // BUFFER_H
